/* ////////////////////////////////////////////////////////////////////////////
 * File:        comstl_com_cast.h
 *
 * Purpose:     Safe interface casting functions.
 *
 * Created:
 * Updated:     2nd July 2003
 *
 * Author:      Matthew Wilson, Synesis Software Pty Ltd.
 *
 * License:     (Licensed under the Synesis Software Standard Source License)
 *
 *              Copyright (C) 2002-2003, Synesis Software Pty Ltd.
 *
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/comstl
 *                          http://www.comstl.org/
 *
 *              email:      submissions@comstl.org  for submissions
 *                          admin@comstl.org        for other enquiries
 *
 *              Redistribution and use in source and binary forms, with or
 *              without modification, are permitted provided that the following
 *              conditions are met:
 *
 *              (i) Redistributions of source code must retain the above
 *              copyright notice and contact information, this list of
 *              conditions and the following disclaimer.
 *
 *              (ii) Any derived versions of this software (howsoever modified)
 *              remain the sole property of Synesis Software.
 *
 *              (iii) Any derived versions of this software (howsoever modified)
 *              remain subject to all these conditions.
 *
 *              (iv) Neither the name of Synesis Software nor the names of any
 *              subdivisions, employees or agents of Synesis Software, nor the
 *              names of any other contributors to this software may be used to
 *              endorse or promote products derived from this software without
 *              specific prior written permission.
 *
 *              This source code is provided by Synesis Software "as is" and any
 *              warranties, whether expressed or implied, including, but not
 *              limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software be liable for any direct, indirect,
 *              incidental, special, exemplary, or consequential damages
 *              (including, but not limited to, procurement of substitute goods
 *              or services; loss of use, data, or profits; or business
 *              interruption) however caused and on any theory of liability,
 *              whether in contract, strict liability, or tort (including
 *              negligence or otherwise) arising in any way out of the use of
 *              this software, even if advised of the possibility of such
 *              damage.
 *
 * ////////////////////////////////////////////////////////////////////////// */


#ifndef _COMSTL_INCL_H_COMSTL_COM_CAST
#define _COMSTL_INCL_H_COMSTL_COM_CAST

#ifndef __STLSOFT_DOCUMENTATION_SKIP_SECTION
#define _COMSTL_VER_H_COMSTL_COM_CAST_MAJOR     1
#define _COMSTL_VER_H_COMSTL_COM_CAST_MINOR     1
#define _COMSTL_VER_H_COMSTL_COM_CAST_REVISION  5
#define _COMSTL_VER_H_COMSTL_COM_CAST_EDIT      18
#endif /* !__STLSOFT_DOCUMENTATION_SKIP_SECTION */

/* ////////////////////////////////////////////////////////////////////////////
 * Includes
 */

/// \file comstl_com_cast.h
///
/// This file is obsolete, and will be removed in a future version. You should include comstl_interface_cast.h

#include "comstl.h"                   // Include the COMSTL root header
#ifdef _COMSTL_STRICT
 #error This file is obsolete, and will be removed in a forthcoming release. The interface_cast classes are now located in comstl_interface_cast.h
#else
 #pragma message("This file is obsolete, and will be removed in a forthcoming release. The interface_cast classes are now located in comstl_interface_cast.h. Including now")
 #include "comstl_interface_cast.h"
#endif /* _COMSTL_STRICT */

/* ////////////////////////////////////////////////////////////////////////// */

#endif /* !_COMSTL_INCL_H_COMSTL_COM_CAST */

/* ////////////////////////////////////////////////////////////////////////// */
