/* /////////////////////////////////////////////////////////////////////////////
 * File:        constraints_test.cpp
 *
 * Purpose:     
 *
 * Created:     
 * Updated:     31st May 2003
 *
 * Author:      Matthew Wilson
 *
 * Copyright:   Synesis Software Pty Ltd, (c) 2002. All rights reserved.
 *
 * Home:        www.stlsoft.org
 *
 * ////////////////////////////////////////////////////////////////////////// */


// This will cause various compile-time messages to be emitted. When you get
// sick of them just comment out or remove this #define
#define	_STLSOFT_COMPILE_VERBOSE

#include <stdio.h>

#include <stlsoft.h>
#include <stlsoft_constraints.h>

#include <string>

// Enable the following to show how Complex and std::string violate the
// type_is_non_class_or_trivial_class constraint
//#define _CT_SHOW_BAD

////////////////////////////////////////////////////////////////////////////////
// Typedefs

struct Simple
{
};

struct Intermediate
{
    Intermediate()
    {}
};

struct Complex
{
    Complex()
    {}

    Complex(Complex const & /* rhs */)
    {}

    Complex &operator =(Complex const & /* rhs */)
    {
        return *this;
    }
};

////////////////////////////////////////////////////////////////////////////////
// main

int main(int /* argc */, char* /* argv */[])
{
    stlsoft_constraint_type_is_non_class_or_trivial_class(int);
    stlsoft_constraint_type_is_non_class_or_trivial_class(Simple);
#ifdef _CT_SHOW_BAD
    stlsoft_constraint_type_is_non_class_or_trivial_class(Complex);
    stlsoft_constraint_type_is_non_class_or_trivial_class(string);
#endif /* _CT_SHOW_BAD */

	stlsoft_constraint_type_is_non_class_or_trivial_class(char);
	stlsoft_constraint_type_is_non_class_or_trivial_class(short);
	stlsoft_constraint_type_is_non_class_or_trivial_class(long);

    return 0;
}

////////////////////////////////////////////////////////////////////////////////
