/* /////////////////////////////////////////////////////////////////////////////
 * File:        num_elements_test.cpp
 *
 * Purpose:     Testing the stlsoft_num_elements() smart-macro.
 *
 * Created:     
 * Updated:     27th July 2003
 *
 * Author:      Matthew Wilson
 *
 * Copyright:   Synesis Software Pty Ltd, (c) 2002. All rights reserved.
 *
 * Home:        www.stlsoft.org
 *
 * ////////////////////////////////////////////////////////////////////////// */


// This will cause various compile-time messages to be emitted. When you get
// sick of them just comment out or remove this #define
#define	_STLSOFT_COMPILE_VERBOSE

// Enable the following testing symbols to see how the compilers catch the errors

//#define   TEST_ERROR_0    // Most compilers catch this one
//#define   TEST_ERROR_1    // Only Borland, Comeau, Intel, Metrowerks and VC.NET catch this one
//#define   TEST_ERROR_2    // Only Borland, Comeau, Intel, Metrowerks and VC.NET catch this one

#include <stlsoft.h>

#include <stdio.h>

////////////////////////////////////////////////////////////////////////////////
// Typedefs

template <ss_typename_param_k T>
struct vect
{
    T &operator [](size_t index)
    {
        return *static_cast<T*>(0);
    }
};

////////////////////////////////////////////////////////////////////////////////
// main

int main(int /* argc */, char* /* argv */[])
{
    int                 ai[20];
#ifdef TEST_ERROR_0
    int                 i;
#endif // TEST_ERROR_0
#ifdef TEST_ERROR_1
    int                 val =   32;
    int                 *pi =   &val;
#endif // TEST_ERROR_1
#ifdef TEST_ERROR_2
    vect<int>           vi;
#endif // TEST_ERROR_2

    fprintf(stdout, "Number of elements in ai: %u\n", stlsoft_num_elements(ai));
#ifdef TEST_ERROR_0
    fprintf(stdout, "Number of elements in i: %u\n", stlsoft_num_elements(i));
#endif // TEST_ERROR_0
#ifdef TEST_ERROR_1
    fprintf(stdout, "Number of elements in pi: %u\n", stlsoft_num_elements(pi));
#endif // TEST_ERROR_1
#ifdef TEST_ERROR_2
    fprintf(stdout, "Number of elements in vi: %u\n", stlsoft_num_elements(vi));
#endif // TEST_ERROR_2

	((void)ai);

	int	a1[1];
	int	a2[2];
	int	a3[3];
	int	a4[4];
	int	a5[5];
	int	a6[6];
	int	a7[7];
	int	a8[8];
	int	a9[9];
	int	a10[10];
	int	a11[11];
	int	a12[12];
	int	a13[13];
	int	a14[14];
	int	a15[15];
	int	a16[16];
	int	a17[17];

	stlsoft_static_assert(stlsoft_num_elements(a1) == 1);
	stlsoft_static_assert(stlsoft_num_elements(a2) == 2);
	stlsoft_static_assert(stlsoft_num_elements(a3) == 3);
	stlsoft_static_assert(stlsoft_num_elements(a4) == 4);
	stlsoft_static_assert(stlsoft_num_elements(a5) == 5);
	stlsoft_static_assert(stlsoft_num_elements(a6) == 6);
	stlsoft_static_assert(stlsoft_num_elements(a7) == 7);
	stlsoft_static_assert(stlsoft_num_elements(a8) == 8);
	stlsoft_static_assert(stlsoft_num_elements(a9) == 9);
	stlsoft_static_assert(stlsoft_num_elements(a10) == 10);
	stlsoft_static_assert(stlsoft_num_elements(a11) == 11);
	stlsoft_static_assert(stlsoft_num_elements(a12) == 12);
	stlsoft_static_assert(stlsoft_num_elements(a13) == 13);
	stlsoft_static_assert(stlsoft_num_elements(a14) == 14);
	stlsoft_static_assert(stlsoft_num_elements(a15) == 15);
	stlsoft_static_assert(stlsoft_num_elements(a16) == 16);
	stlsoft_static_assert(stlsoft_num_elements(a17) == 17);

	((void)a1);
    ((void)a2);
    ((void)a3);
    ((void)a4);
    ((void)a5);
    ((void)a6);
    ((void)a7);
    ((void)a8);
    ((void)a9);
    ((void)a10);
    ((void)a11);
    ((void)a12);
    ((void)a13);
    ((void)a14);
    ((void)a15);
    ((void)a16);
    ((void)a17);

#ifdef TEST_ERROR_1
    return pi != NULL;
#else
    return 0;
#endif // TEST_ERROR_1
}

////////////////////////////////////////////////////////////////////////////////
